<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE sect2 SYSTEM "../../../dtd/dblite.dtd">

<sect2 lang="en" id="git-send-email(1)">
    <title>git-send-email(1)</title>
    <date>2024-07-02</date>
<revhistory><revision><date>2024-07-02</date></revision></revhistory>
<indexterm>
<primary>git-send-email(1)</primary>
</indexterm>
<simplesect id="git-send-email(1)__name">
<title>NAME</title>
<simpara>git-send-email - Send a collection of patches as emails</simpara>
</simplesect>
<simplesect id="git-send-email(1)__synopsis">
<title>SYNOPSIS</title>
<blockquote>
<literallayout><emphasis>git send-email</emphasis> [&lt;options&gt;] (&lt;file&gt;|&lt;directory&gt;)&#8230;
<emphasis>git send-email</emphasis> [&lt;options&gt;] &lt;format-patch-options&gt;
<emphasis>git send-email</emphasis> --dump-aliases</literallayout>
</blockquote>
</simplesect>
<simplesect id="git-send-email(1)__description">
<title>DESCRIPTION</title>
<simpara>Takes the patches given on the command line and emails them out.
Patches can be specified as files, directories (which will send all
files in the directory), or directly as a revision list.  In the
last case, any format accepted by <xref linkend="git-format-patch(1)" /> can
be passed to git send-email, as well as options understood by
<xref linkend="git-format-patch(1)" />.</simpara>
<simpara>The header of the email is configurable via command-line options.  If not
specified on the command line, the user will be prompted with a ReadLine
enabled interface to provide the necessary information.</simpara>
<simpara>There are two formats accepted for patch files:</simpara>
<orderedlist numeration="arabic">
<listitem>
<simpara>
mbox format files
</simpara>
<simpara>This is what <xref linkend="git-format-patch(1)" /> generates.  Most headers and MIME
formatting are ignored.</simpara>
</listitem>
<listitem>
<simpara>
The original format used by Greg Kroah-Hartman's <emphasis>send_lots_of_email.pl</emphasis>
   script
</simpara>
<simpara>This format expects the first line of the file to contain the "Cc:" value
and the "Subject:" of the message as the second line.</simpara>
</listitem>
</orderedlist>
</simplesect>
<simplesect id="git-send-email(1)__options">
<title>OPTIONS</title>
<section id="git-send-email(1)__composing">
<title>Composing</title>
<variablelist>
<varlistentry>
<term>
--annotate
</term>
<listitem>
<simpara>
        Review and edit each patch you're about to send. Default is the value
        of <emphasis>sendemail.annotate</emphasis>. See the CONFIGURATION section for
        <emphasis>sendemail.multiEdit</emphasis>.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--bcc=&lt;address&gt;,&#8230;
</term>
<listitem>
<simpara>
        Specify a "Bcc:" value for each email. Default is the value of
        <emphasis>sendemail.bcc</emphasis>.
</simpara>
<simpara>This option may be specified multiple times.</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--cc=&lt;address&gt;,&#8230;
</term>
<listitem>
<simpara>
        Specify a starting "Cc:" value for each email.
        Default is the value of <emphasis>sendemail.cc</emphasis>.
</simpara>
<simpara>This option may be specified multiple times.</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--compose
</term>
<listitem>
<simpara>
        Invoke a text editor (see GIT_EDITOR in <xref linkend="git-var(1)" />)
        to edit an introductory message for the patch series.
</simpara>
<simpara>When <emphasis>--compose</emphasis> is used, git send-email will use the From, To, Cc, Bcc,
Subject, Reply-To, and In-Reply-To headers specified in the message. If
the body of the message (what you type after the headers and a blank
line) only contains blank (or Git: prefixed) lines, the summary won't be
sent, but the headers mentioned above will be used unless they are
removed.</simpara>
<simpara>Missing From or In-Reply-To headers will be prompted for.</simpara>
<simpara>See the CONFIGURATION section for <emphasis>sendemail.multiEdit</emphasis>.</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--from=&lt;address&gt;
</term>
<listitem>
<simpara>
        Specify the sender of the emails.  If not specified on the command line,
        the value of the <emphasis>sendemail.from</emphasis> configuration option is used.  If
        neither the command-line option nor <emphasis>sendemail.from</emphasis> are set, then the
        user will be prompted for the value.  The default for the prompt will be
        the value of GIT_AUTHOR_IDENT, or GIT_COMMITTER_IDENT if that is not
        set, as returned by "git var -l".
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--reply-to=&lt;address&gt;
</term>
<listitem>
<simpara>
        Specify the address where replies from recipients should go to.
        Use this if replies to messages should go to another address than what
        is specified with the --from parameter.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--in-reply-to=&lt;identifier&gt;
</term>
<listitem>
<simpara>
        Make the first mail (or all the mails with <emphasis>--no-thread</emphasis>) appear as a
        reply to the given Message-ID, which avoids breaking threads to
        provide a new patch series.
        The second and subsequent emails will be sent as replies according to
        the <emphasis>--[no-]chain-reply-to</emphasis> setting.
</simpara>
<simpara>So for example when <emphasis>--thread</emphasis> and <emphasis>--no-chain-reply-to</emphasis> are specified, the
second and subsequent patches will be replies to the first one like in the
illustration below where <emphasis>[PATCH v2 0/3]</emphasis> is in reply to <emphasis>[PATCH 0/2]</emphasis>:</simpara>
<literallayout class="monospaced">[PATCH 0/2] Here is what I did...
  [PATCH 1/2] Clean up and tests
  [PATCH 2/2] Implementation
  [PATCH v2 0/3] Here is a reroll
    [PATCH v2 1/3] Clean up
    [PATCH v2 2/3] New tests
    [PATCH v2 3/3] Implementation</literallayout>
<simpara>Only necessary if --compose is also set.  If --compose
is not set, this will be prompted for.</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--subject=&lt;string&gt;
</term>
<listitem>
<simpara>
        Specify the initial subject of the email thread.
        Only necessary if --compose is also set.  If --compose
        is not set, this will be prompted for.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--to=&lt;address&gt;,&#8230;
</term>
<listitem>
<simpara>
        Specify the primary recipient of the emails generated. Generally, this
        will be the upstream maintainer of the project involved. Default is the
        value of the <emphasis>sendemail.to</emphasis> configuration value; if that is unspecified,
        and --to-cmd is not specified, this will be prompted for.
</simpara>
<simpara>This option may be specified multiple times.</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--8bit-encoding=&lt;encoding&gt;
</term>
<listitem>
<simpara>
        When encountering a non-ASCII message or subject that does not
        declare its encoding, add headers/quoting to indicate it is
        encoded in &lt;encoding&gt;.  Default is the value of the
        <emphasis>sendemail.assume8bitEncoding</emphasis>; if that is unspecified, this
        will be prompted for if any non-ASCII files are encountered.
</simpara>
<simpara>Note that no attempts whatsoever are made to validate the encoding.</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--compose-encoding=&lt;encoding&gt;
</term>
<listitem>
<simpara>
        Specify encoding of compose message. Default is the value of the
        <emphasis>sendemail.composeEncoding</emphasis>; if that is unspecified, UTF-8 is assumed.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--transfer-encoding=(7bit|8bit|quoted-printable|base64|auto)
</term>
<listitem>
<simpara>
        Specify the transfer encoding to be used to send the message over SMTP.
        7bit will fail upon encountering a non-ASCII message.  quoted-printable
        can be useful when the repository contains files that contain carriage
        returns, but makes the raw patch email file (as saved from a MUA) much
        harder to inspect manually.  base64 is even more fool proof, but also
        even more opaque.  auto will use 8bit when possible, and quoted-printable
        otherwise.
</simpara>
<simpara>Default is the value of the <emphasis>sendemail.transferEncoding</emphasis> configuration
value; if that is unspecified, default to <emphasis>auto</emphasis>.</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--xmailer
</term>
<term>
--no-xmailer
</term>
<listitem>
<simpara>
        Add (or prevent adding) the "X-Mailer:" header.  By default,
        the header is added, but it can be turned off by setting the
        <emphasis>sendemail.xmailer</emphasis> configuration variable to <emphasis>false</emphasis>.
</simpara>
</listitem>
</varlistentry>
</variablelist>
</section>
<section id="git-send-email(1)__sending">
<title>Sending</title>
<variablelist>
<varlistentry>
<term>
--envelope-sender=&lt;address&gt;
</term>
<listitem>
<simpara>
        Specify the envelope sender used to send the emails.
        This is useful if your default address is not the address that is
        subscribed to a list. In order to use the <emphasis>From</emphasis> address, set the
        value to "auto". If you use the sendmail binary, you must have
        suitable privileges for the -f parameter.  Default is the value of the
        <emphasis>sendemail.envelopeSender</emphasis> configuration variable; if that is
        unspecified, choosing the envelope sender is left to your MTA.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--sendmail-cmd=&lt;command&gt;
</term>
<listitem>
<simpara>
        Specify a command to run to send the email. The command should
        be sendmail-like; specifically, it must support the <emphasis>-i</emphasis> option.
        The command will be executed in the shell if necessary.  Default
        is the value of <emphasis>sendemail.sendmailCmd</emphasis>.  If unspecified, and if
        --smtp-server is also unspecified, git-send-email will search
        for <emphasis>sendmail</emphasis> in <emphasis>/usr/sbin</emphasis>, <emphasis>/usr/lib</emphasis> and $PATH.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--smtp-encryption=&lt;encryption&gt;
</term>
<listitem>
<simpara>
        Specify in what way encrypting begins for the SMTP connection.
        Valid values are <emphasis>ssl</emphasis> and <emphasis>tls</emphasis>. Any other value reverts to plain
        (unencrypted) SMTP, which defaults to port 25.
        Despite the names, both values will use the same newer version of TLS,
        but for historic reasons have these names. <emphasis>ssl</emphasis> refers to "implicit"
        encryption (sometimes called SMTPS), that uses port 465 by default.
        <emphasis>tls</emphasis> refers to "explicit" encryption (often known as STARTTLS),
        that uses port 25 by default. Other ports might be used by the SMTP
        server, which are not the default. Commonly found alternative port for
        <emphasis>tls</emphasis> and unencrypted is 587. You need to check your provider's
        documentation or your server configuration to make sure
        for your own case. Default is the value of <emphasis>sendemail.smtpEncryption</emphasis>.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--smtp-domain=&lt;FQDN&gt;
</term>
<listitem>
<simpara>
        Specifies the Fully Qualified Domain Name (FQDN) used in the
        HELO/EHLO command to the SMTP server.  Some servers require the
        FQDN to match your IP address.  If not set, git send-email attempts
        to determine your FQDN automatically.  Default is the value of
        <emphasis>sendemail.smtpDomain</emphasis>.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--smtp-auth=&lt;mechanisms&gt;
</term>
<listitem>
<simpara>
        Whitespace-separated list of allowed SMTP-AUTH mechanisms. This setting
        forces using only the listed mechanisms. Example:
</simpara>
<screen>$ git send-email --smtp-auth="PLAIN LOGIN GSSAPI" ...</screen>
<simpara>If at least one of the specified mechanisms matches the ones advertised by the
SMTP server and if it is supported by the utilized SASL library, the mechanism
is used for authentication. If neither <emphasis>sendemail.smtpAuth</emphasis> nor <emphasis>--smtp-auth</emphasis>
is specified, all mechanisms supported by the SASL library can be used. The
special value <emphasis>none</emphasis> maybe specified to completely disable authentication
independently of <emphasis>--smtp-user</emphasis></simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--smtp-pass[=&lt;password&gt;]
</term>
<listitem>
<simpara>
        Password for SMTP-AUTH. The argument is optional: If no
        argument is specified, then the empty string is used as
        the password. Default is the value of <emphasis>sendemail.smtpPass</emphasis>,
        however <emphasis>--smtp-pass</emphasis> always overrides this value.
</simpara>
<simpara>Furthermore, passwords need not be specified in configuration files
or on the command line. If a username has been specified (with
<emphasis>--smtp-user</emphasis> or a <emphasis>sendemail.smtpUser</emphasis>), but no password has been
specified (with <emphasis>--smtp-pass</emphasis> or <emphasis>sendemail.smtpPass</emphasis>), then
a password is obtained using <emphasis>git-credential</emphasis>.</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--no-smtp-auth
</term>
<listitem>
<simpara>
        Disable SMTP authentication. Short hand for <emphasis>--smtp-auth=none</emphasis>
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--smtp-server=&lt;host&gt;
</term>
<listitem>
<simpara>
        If set, specifies the outgoing SMTP server to use (e.g.
        <emphasis>smtp.example.com</emphasis> or a raw IP address).  If unspecified, and if
        <emphasis>--sendmail-cmd</emphasis> is also unspecified, the default is to search
        for <emphasis>sendmail</emphasis> in <emphasis>/usr/sbin</emphasis>, <emphasis>/usr/lib</emphasis> and $PATH if such a
        program is available, falling back to <emphasis>localhost</emphasis> otherwise.
</simpara>
<simpara>For backward compatibility, this option can also specify a full pathname
of a sendmail-like program instead; the program must support the <emphasis>-i</emphasis>
option.  This method does not support passing arguments or using plain
command names.  For those use cases, consider using <emphasis>--sendmail-cmd</emphasis>
instead.</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--smtp-server-port=&lt;port&gt;
</term>
<listitem>
<simpara>
        Specifies a port different from the default port (SMTP
        servers typically listen to smtp port 25, but may also listen to
        submission port 587, or the common SSL smtp port 465);
        symbolic port names (e.g. "submission" instead of 587)
        are also accepted. The port can also be set with the
        <emphasis>sendemail.smtpServerPort</emphasis> configuration variable.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--smtp-server-option=&lt;option&gt;
</term>
<listitem>
<simpara>
        If set, specifies the outgoing SMTP server option to use.
        Default value can be specified by the <emphasis>sendemail.smtpServerOption</emphasis>
        configuration option.
</simpara>
<simpara>The --smtp-server-option option must be repeated for each option you want
to pass to the server. Likewise, different lines in the configuration files
must be used for each option.</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--smtp-ssl
</term>
<listitem>
<simpara>
        Legacy alias for <emphasis>--smtp-encryption ssl</emphasis>.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--smtp-ssl-cert-path
</term>
<listitem>
<simpara>
        Path to a store of trusted CA certificates for SMTP SSL/TLS
        certificate validation (either a directory that has been processed
        by <emphasis>c_rehash</emphasis>, or a single file containing one or more PEM format
        certificates concatenated together: see verify(1) -CAfile and
        -CApath for more information on these). Set it to an empty string
        to disable certificate verification. Defaults to the value of the
        <emphasis>sendemail.smtpSSLCertPath</emphasis> configuration variable, if set, or the
        backing SSL library's compiled-in default otherwise (which should
        be the best choice on most platforms).
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--smtp-user=&lt;user&gt;
</term>
<listitem>
<simpara>
        Username for SMTP-AUTH. Default is the value of <emphasis>sendemail.smtpUser</emphasis>;
        if a username is not specified (with <emphasis>--smtp-user</emphasis> or <emphasis>sendemail.smtpUser</emphasis>),
        then authentication is not attempted.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--smtp-debug=(0|1)
</term>
<listitem>
<simpara>
        Enable (1) or disable (0) debug output. If enabled, SMTP
        commands and replies will be printed. Useful to debug TLS
        connection and authentication problems.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--batch-size=&lt;num&gt;
</term>
<listitem>
<simpara>
        Some email servers (e.g. smtp.163.com) limit the number emails to be
        sent per session (connection) and this will lead to a failure when
        sending many messages.  With this option, send-email will disconnect after
        sending $&lt;num&gt; messages and wait for a few seconds (see --relogin-delay)
        and reconnect, to work around such a limit.  You may want to
        use some form of credential helper to avoid having to retype
        your password every time this happens.  Defaults to the
        <emphasis>sendemail.smtpBatchSize</emphasis> configuration variable.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--relogin-delay=&lt;int&gt;
</term>
<listitem>
<simpara>
        Waiting $&lt;int&gt; seconds before reconnecting to SMTP server. Used together
        with --batch-size option.  Defaults to the <emphasis>sendemail.smtpReloginDelay</emphasis>
        configuration variable.
</simpara>
</listitem>
</varlistentry>
</variablelist>
</section>
<section id="git-send-email(1)__automating">
<title>Automating</title>
<variablelist>
<varlistentry>
<term>
--no-to
</term>
<term>
--no-cc
</term>
<term>
--no-bcc
</term>
<listitem>
<simpara>
        Clears any list of "To:", "Cc:", "Bcc:" addresses previously
        set via config.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--no-identity
</term>
<listitem>
<simpara>
        Clears the previously read value of <emphasis>sendemail.identity</emphasis> set
        via config, if any.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--to-cmd=&lt;command&gt;
</term>
<listitem>
<simpara>
        Specify a command to execute once per patch file which
        should generate patch file specific "To:" entries.
        Output of this command must be single email address per line.
        Default is the value of <emphasis>sendemail.toCmd</emphasis> configuration value.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--cc-cmd=&lt;command&gt;
</term>
<listitem>
<simpara>
        Specify a command to execute once per patch file which
        should generate patch file specific "Cc:" entries.
        Output of this command must be single email address per line.
        Default is the value of <emphasis>sendemail.ccCmd</emphasis> configuration value.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--header-cmd=&lt;command&gt;
</term>
<listitem>
<simpara>
        Specify a command that is executed once per outgoing message
        and output RFC 2822 style header lines to be inserted into
        them. When the <emphasis>sendemail.headerCmd</emphasis> configuration variable is
        set, its value is always used. When --header-cmd is provided
        at the command line, its value takes precedence over the
        <emphasis>sendemail.headerCmd</emphasis> configuration variable.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--no-header-cmd
</term>
<listitem>
<simpara>
        Disable any header command in use.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--[no-]chain-reply-to
</term>
<listitem>
<simpara>
        If this is set, each email will be sent as a reply to the previous
        email sent.  If disabled with "--no-chain-reply-to", all emails after
        the first will be sent as replies to the first email sent.  When using
        this, it is recommended that the first file given be an overview of the
        entire patch series. Disabled by default, but the <emphasis>sendemail.chainReplyTo</emphasis>
        configuration variable can be used to enable it.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--identity=&lt;identity&gt;
</term>
<listitem>
<simpara>
        A configuration identity. When given, causes values in the
        <emphasis>sendemail.&lt;identity&gt;</emphasis> subsection to take precedence over
        values in the <emphasis>sendemail</emphasis> section. The default identity is
        the value of <emphasis>sendemail.identity</emphasis>.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--[no-]signed-off-by-cc
</term>
<listitem>
<simpara>
        If this is set, add emails found in the <emphasis>Signed-off-by</emphasis> trailer or Cc: lines to the
        cc list. Default is the value of <emphasis>sendemail.signedOffByCc</emphasis> configuration
        value; if that is unspecified, default to --signed-off-by-cc.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--[no-]cc-cover
</term>
<listitem>
<simpara>
        If this is set, emails found in Cc: headers in the first patch of
        the series (typically the cover letter) are added to the cc list
        for each email set. Default is the value of <emphasis>sendemail.ccCover</emphasis>
        configuration value; if that is unspecified, default to --no-cc-cover.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--[no-]to-cover
</term>
<listitem>
<simpara>
        If this is set, emails found in To: headers in the first patch of
        the series (typically the cover letter) are added to the to list
        for each email set. Default is the value of <emphasis>sendemail.toCover</emphasis>
        configuration value; if that is unspecified, default to --no-to-cover.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--suppress-cc=&lt;category&gt;
</term>
<listitem>
<simpara>
        Specify an additional category of recipients to suppress the
        auto-cc of:
</simpara>
<itemizedlist>
<listitem>
<simpara>
<emphasis>author</emphasis> will avoid including the patch author.
</simpara>
</listitem>
<listitem>
<simpara>
<emphasis>self</emphasis> will avoid including the sender.
</simpara>
</listitem>
<listitem>
<simpara>
<emphasis>cc</emphasis> will avoid including anyone mentioned in Cc lines in the patch header
  except for self (use <emphasis>self</emphasis> for that).
</simpara>
</listitem>
<listitem>
<simpara>
<emphasis>bodycc</emphasis> will avoid including anyone mentioned in Cc lines in the
  patch body (commit message) except for self (use <emphasis>self</emphasis> for that).
</simpara>
</listitem>
<listitem>
<simpara>
<emphasis>sob</emphasis> will avoid including anyone mentioned in the Signed-off-by trailers except
  for self (use <emphasis>self</emphasis> for that).
</simpara>
</listitem>
<listitem>
<simpara>
<emphasis>misc-by</emphasis> will avoid including anyone mentioned in Acked-by,
  Reviewed-by, Tested-by and other "-by" lines in the patch body,
  except Signed-off-by (use <emphasis>sob</emphasis> for that).
</simpara>
</listitem>
<listitem>
<simpara>
<emphasis>cccmd</emphasis> will avoid running the --cc-cmd.
</simpara>
</listitem>
<listitem>
<simpara>
<emphasis>body</emphasis> is equivalent to <emphasis>sob</emphasis> + <emphasis>bodycc</emphasis> + <emphasis>misc-by</emphasis>.
</simpara>
</listitem>
<listitem>
<simpara>
<emphasis>all</emphasis> will suppress all auto cc values.
</simpara>
</listitem>
</itemizedlist>
<simpara>Default is the value of <emphasis>sendemail.suppressCc</emphasis> configuration value; if
that is unspecified, default to <emphasis>self</emphasis> if --suppress-from is
specified, as well as <emphasis>body</emphasis> if --no-signed-off-cc is specified.</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--[no-]suppress-from
</term>
<listitem>
<simpara>
        If this is set, do not add the From: address to the cc: list.
        Default is the value of <emphasis>sendemail.suppressFrom</emphasis> configuration
        value; if that is unspecified, default to --no-suppress-from.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--[no-]thread
</term>
<listitem>
<simpara>
        If this is set, the In-Reply-To and References headers will be
        added to each email sent.  Whether each mail refers to the
        previous email (<emphasis>deep</emphasis> threading per <emphasis>git format-patch</emphasis>
        wording) or to the first email (<emphasis>shallow</emphasis> threading) is
        governed by "--[no-]chain-reply-to".
</simpara>
<simpara>If disabled with "--no-thread", those headers will not be added
(unless specified with --in-reply-to).  Default is the value of the
<emphasis>sendemail.thread</emphasis> configuration value; if that is unspecified,
default to --thread.</simpara>
<simpara>It is up to the user to ensure that no In-Reply-To header already
exists when <emphasis>git send-email</emphasis> is asked to add it (especially note that
<emphasis>git format-patch</emphasis> can be configured to do the threading itself).
Failure to do so may not produce the expected result in the
recipient's MUA.</simpara>
</listitem>
</varlistentry>
</variablelist>
</section>
<section id="git-send-email(1)__administering">
<title>Administering</title>
<variablelist>
<varlistentry>
<term>
--confirm=&lt;mode&gt;
</term>
<listitem>
<simpara>
        Confirm just before sending:
</simpara>
<itemizedlist>
<listitem>
<simpara>
<emphasis>always</emphasis> will always confirm before sending
</simpara>
</listitem>
<listitem>
<simpara>
<emphasis>never</emphasis> will never confirm before sending
</simpara>
</listitem>
<listitem>
<simpara>
<emphasis>cc</emphasis> will confirm before sending when send-email has automatically
  added addresses from the patch to the Cc list
</simpara>
</listitem>
<listitem>
<simpara>
<emphasis>compose</emphasis> will confirm before sending the first message when using --compose.
</simpara>
</listitem>
<listitem>
<simpara>
<emphasis>auto</emphasis> is equivalent to <emphasis>cc</emphasis> + <emphasis>compose</emphasis>
</simpara>
</listitem>
</itemizedlist>
<simpara>Default is the value of <emphasis>sendemail.confirm</emphasis> configuration value; if that
is unspecified, default to <emphasis>auto</emphasis> unless any of the suppress options
have been specified, in which case default to <emphasis>compose</emphasis>.</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--dry-run
</term>
<listitem>
<simpara>
        Do everything except actually send the emails.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--[no-]format-patch
</term>
<listitem>
<simpara>
        When an argument may be understood either as a reference or as a file name,
        choose to understand it as a format-patch argument (<emphasis>--format-patch</emphasis>)
        or as a file name (<emphasis>--no-format-patch</emphasis>). By default, when such a conflict
        occurs, git send-email will fail.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--quiet
</term>
<listitem>
<simpara>
        Make git-send-email less verbose.  One line per email should be
        all that is output.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--[no-]validate
</term>
<listitem>
<simpara>
        Perform sanity checks on patches.
        Currently, validation means the following:
</simpara>
<itemizedlist>
<listitem>
<simpara>
Invoke the sendemail-validate hook if present (see <xref linkend="githooks(5)" />).
</simpara>
</listitem>
<listitem>
<simpara>
Warn of patches that contain lines longer than
                        998 characters unless a suitable transfer encoding
                        (<emphasis>auto</emphasis>, <emphasis>base64</emphasis>, or <emphasis>quoted-printable</emphasis>) is used;
                        this is due to SMTP limits as described by
                        <ulink url="https://www.ietf.org/rfc/rfc5322.txt">https://www.ietf.org/rfc/rfc5322.txt</ulink>.
</simpara>
</listitem>
</itemizedlist>
<simpara>Default is the value of <emphasis>sendemail.validate</emphasis>; if this is not set,
default to <emphasis>--validate</emphasis>.</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
--force
</term>
<listitem>
<simpara>
        Send emails even if safety checks would prevent it.
</simpara>
</listitem>
</varlistentry>
</variablelist>
</section>
<section id="git-send-email(1)__information">
<title>Information</title>
<variablelist>
<varlistentry>
<term>
--dump-aliases
</term>
<listitem>
<simpara>
        Instead of the normal operation, dump the shorthand alias names from
        the configured alias file(s), one per line in alphabetical order. Note
        that this only includes the alias name and not its expanded email addresses.
        See <emphasis>sendemail.aliasesFile</emphasis> for more information about aliases.
</simpara>
</listitem>
</varlistentry>
</variablelist>
</section>
</simplesect>
<simplesect id="git-send-email(1)__configuration">
<title>CONFIGURATION</title>
<simpara>Everything below this line in this section is selectively included
from the <xref linkend="git-config(1)" /> documentation. The content is the same
as what's found there:</simpara>
<variablelist>
<varlistentry>
<term>
sendemail.identity
</term>
<listitem>
<simpara>
        A configuration identity. When given, causes values in the
        <emphasis>sendemail.&lt;identity&gt;</emphasis> subsection to take precedence over
        values in the <emphasis>sendemail</emphasis> section. The default identity is
        the value of <emphasis>sendemail.identity</emphasis>.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
sendemail.smtpEncryption
</term>
<listitem>
<simpara>
        See <xref linkend="git-send-email(1)" /> for description.  Note that this
        setting is not subject to the <emphasis>identity</emphasis> mechanism.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
sendemail.smtpSSLCertPath
</term>
<listitem>
<simpara>
        Path to ca-certificates (either a directory or a single file).
        Set it to an empty string to disable certificate verification.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
sendemail.&lt;identity&gt;.*
</term>
<listitem>
<simpara>
        Identity-specific versions of the <emphasis>sendemail.*</emphasis> parameters
        found below, taking precedence over those when this
        identity is selected, through either the command-line or
        <emphasis>sendemail.identity</emphasis>.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
sendemail.multiEdit
</term>
<listitem>
<simpara>
        If true (default), a single editor instance will be spawned to edit
        files you have to edit (patches when <emphasis>--annotate</emphasis> is used, and the
        summary when <emphasis>--compose</emphasis> is used). If false, files will be edited one
        after the other, spawning a new editor each time.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
sendemail.confirm
</term>
<listitem>
<simpara>
        Sets the default for whether to confirm before sending. Must be
        one of <emphasis>always</emphasis>, <emphasis>never</emphasis>, <emphasis>cc</emphasis>, <emphasis>compose</emphasis>, or <emphasis>auto</emphasis>. See <emphasis>--confirm</emphasis>
        in the <xref linkend="git-send-email(1)" /> documentation for the meaning of these
        values.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
sendemail.aliasesFile
</term>
<listitem>
<simpara>
        To avoid typing long email addresses, point this to one or more
        email aliases files.  You must also supply <emphasis>sendemail.aliasFileType</emphasis>.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
sendemail.aliasFileType
</term>
<listitem>
<simpara>
        Format of the file(s) specified in sendemail.aliasesFile. Must be
        one of <emphasis>mutt</emphasis>, <emphasis>mailrc</emphasis>, <emphasis>pine</emphasis>, <emphasis>elm</emphasis>, <emphasis>gnus</emphasis>, or <emphasis>sendmail</emphasis>.
</simpara>
<simpara>What an alias file in each format looks like can be found in
the documentation of the email program of the same name. The
differences and limitations from the standard formats are
described below:</simpara>
<variablelist>
<varlistentry>
<term>
sendmail
</term>
<listitem>
<itemizedlist>
<listitem>
<simpara>
Quoted aliases and quoted addresses are not supported: lines that
        contain a <emphasis>"</emphasis> symbol are ignored.
</simpara>
</listitem>
<listitem>
<simpara>
Redirection to a file (<emphasis>/path/name</emphasis>) or pipe (<emphasis>|command</emphasis>) is not
        supported.
</simpara>
</listitem>
<listitem>
<simpara>
File inclusion (<emphasis>:include: /path/name</emphasis>) is not supported.
</simpara>
</listitem>
<listitem>
<simpara>
Warnings are printed on the standard error output for any
        explicitly unsupported constructs, and any other lines that are not
        recognized by the parser.
</simpara>
</listitem>
</itemizedlist>
</listitem>
</varlistentry>
</variablelist>
</listitem>
</varlistentry>
<varlistentry>
<term>
sendemail.annotate
</term>
<term>
sendemail.bcc
</term>
<term>
sendemail.cc
</term>
<term>
sendemail.ccCmd
</term>
<term>
sendemail.chainReplyTo
</term>
<term>
sendemail.envelopeSender
</term>
<term>
sendemail.from
</term>
<term>
sendemail.headerCmd
</term>
<term>
sendemail.signedOffByCc
</term>
<term>
sendemail.smtpPass
</term>
<term>
sendemail.suppressCc
</term>
<term>
sendemail.suppressFrom
</term>
<term>
sendemail.to
</term>
<term>
sendemail.toCmd
</term>
<term>
sendemail.smtpDomain
</term>
<term>
sendemail.smtpServer
</term>
<term>
sendemail.smtpServerPort
</term>
<term>
sendemail.smtpServerOption
</term>
<term>
sendemail.smtpUser
</term>
<term>
sendemail.thread
</term>
<term>
sendemail.transferEncoding
</term>
<term>
sendemail.validate
</term>
<term>
sendemail.xmailer
</term>
<listitem>
<simpara>
        These configuration variables all provide a default for
        <xref linkend="git-send-email(1)" /> command-line options. See its
        documentation for details.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
sendemail.signedOffCc (deprecated)
</term>
<listitem>
<simpara>
        Deprecated alias for <emphasis>sendemail.signedOffByCc</emphasis>.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
sendemail.smtpBatchSize
</term>
<listitem>
<simpara>
        Number of messages to be sent per connection, after that a relogin
        will happen.  If the value is 0 or undefined, send all messages in
        one connection.
        See also the <emphasis>--batch-size</emphasis> option of <xref linkend="git-send-email(1)" />.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
sendemail.smtpReloginDelay
</term>
<listitem>
<simpara>
        Seconds to wait before reconnecting to the smtp server.
        See also the <emphasis>--relogin-delay</emphasis> option of <xref linkend="git-send-email(1)" />.
</simpara>
</listitem>
</varlistentry>
<varlistentry>
<term>
sendemail.forbidSendmailVariables
</term>
<listitem>
<simpara>
        To avoid common misconfiguration mistakes, <xref linkend="git-send-email(1)" />
        will abort with a warning if any configuration options for "sendmail"
        exist. Set this variable to bypass the check.
</simpara>
</listitem>
</varlistentry>
</variablelist>
</simplesect>
<simplesect id="git-send-email(1)__examples">
<title>EXAMPLES</title>
<section id="git-send-email(1)__use_gmail_as_the_smtp_server">
<title>Use gmail as the smtp server</title>
<simpara>To use <emphasis>git send-email</emphasis> to send your patches through the GMail SMTP server,
edit ~/.gitconfig to specify your account settings:</simpara>
<screen>[sendemail]
        smtpEncryption = tls
        smtpServer = smtp.gmail.com
        smtpUser = yourname@gmail.com
        smtpServerPort = 587</screen>
<simpara>If you have multi-factor authentication set up on your Gmail account, you can
generate an app-specific password for use with <emphasis>git send-email</emphasis>. Visit
<ulink url="https://security.google.com/settings/security/apppasswords">https://security.google.com/settings/security/apppasswords</ulink> to create it.</simpara>
<simpara>Once your commits are ready to be sent to the mailing list, run the
following commands:</simpara>
<literallayout class="monospaced">$ git format-patch --cover-letter -M origin/master -o outgoing/
$ edit outgoing/0000-*
$ git send-email outgoing/*</literallayout>
<simpara>The first time you run it, you will be prompted for your credentials.  Enter the
app-specific or your regular password as appropriate.  If you have credential
helper configured (see <xref linkend="git-credential(1)" />), the password will be saved in
the credential store so you won't have to type it the next time.</simpara>
<simpara>Note: the following core Perl modules that may be installed with your
distribution of Perl are required:
MIME::Base64, MIME::QuotedPrint, Net::Domain and Net::SMTP.
These additional Perl modules are also required:
Authen::SASL and Mail::Address.</simpara>
</section>
</simplesect>
<simplesect id="git-send-email(1)__see_also">
<title>SEE ALSO</title>
<simpara><xref linkend="git-format-patch(1)" />, <xref linkend="git-imap-send(1)" />, mbox(5)</simpara>
</simplesect>
<simplesect id="git-send-email(1)__git">
<title>GIT</title>
<simpara>Part of the <xref linkend="git(1)" /> suite</simpara>
</simplesect>
</sect2>
